source(paste(connectomeAnalyzerPath,"ConstructVectorFilter.r", sep=""))
source(paste(connectomeAnalyzerPath,"ComputeK.r", sep=""))
source(paste(connectomeAnalyzerPath,"computePvalue.r", sep=""))
measures=c(measure)
dataGroup1=data$dataGroup1
n1=dim(dataGroup1)[3]
dataGroup2=data$dataGroup2
n2=dim(dataGroup2)[3]
M= dim(dataGroup2)[1]

group1Measures=array(NA,dim=c(n1, length(measures),dim(dataGroup1)[1]))
group2Measures=array(NA,dim=c(n2, length(measures),dim(dataGroup2)[1]))

for(k in 1:n1){
Graph <- graph.adjacency(dataGroup1[,,k], mode="undirected", weighted=TRUE)
group1Measures[k,1,]=measure(Graph)
}

for(k in 1:n2){
Graph <- graph.adjacency(dataGroup2[,,k], mode="undirected", weighted=TRUE)
group2Measures[k,1,]=measure(Graph)
}

p.values=NULL
for (j in 1:dim(dataGroup1)[1]){
p.values=c(p.values,computePvalue(group1Measures[,1,j], group2Measures[,1,j], regressors=regressors,alternative=alternative)$p.value )
}
print("The number of significant results with the AWA")
print(sum(p.adjust(p.values, procedure)<=0.05))


reduceVectorData=function(data, summaryFunction, SubregionsIndices){
# n is the number of subjects
n=dim(data)[1]
# s is the number of subsets
sm=length(unique(SubregionsIndices[,1]))
reducedData=matrix(0,n,sm)
for (ir in 1:sm){    # ir is the row index of the brain subregion i,
rowIndex=as.vector(SubregionsIndices[,2][SubregionsIndices[,1]==ir])
for(k in 1:n){
reducedData[k,ir]=summaryFunction(as.vector(data[k,rowIndex]))
}
}
return(reducedData)
}

reducedgroup1=reduceVectorData(group1Measures[,1,], mean, SubregionsIndices)

reducedgroup2=reduceVectorData(group2Measures[,1,], mean, SubregionsIndices)

sm= length(unique(SubregionsIndices[,1]))
P.values=NULL
for (i in 1:sm){
P.values=c(P.values,computePvalue(reducedgroup1[,i], reducedgroup2[,i], regressors=regressors)$p.value)
}



R=sum(p.adjust(P.values, procedure)<=alpha)



ui1= qnorm(1-alpha/(sm))
if (procedure=="BH"){
ui1= qnorm(1-max(1,R)*alpha/(sm))
}
if (procedure=="fdr"){
ui1= qnorm(1-max(1,R)*alpha/(sm))
}

ui2= qnorm(1-alpha)


# compute relaxation coeficient
Scores= qnorm(1-p.values)
relaxation1=computeK2(alpha2, sm, si=6,scoresMatrix=Scores,step=0.05,initK=1,ui1)

VectorOfSignificantSubsets=P.values<=1-pnorm(ui1)
Filter1=ConstructVectorFilter(VectorOfSignificantSubsets, SubregionsIndices)
print("The number of significant results with the RMWC")
relaxed.p.values=((p.values/relaxation1)*Filter1+(1-Filter1))
print(sum(p.adjust(relaxed.p.values,procedure)<=alpha2))
if (sum(p.adjust(relaxed.p.values,procedure)<=alpha2)>0){
print("The significant locations are")
print(c(1:M)[p.adjust(relaxed.p.values,procedure)<=alpha2])
}

relaxation2=computeK2(alpha2, sm, si=6,scoresMatrix=Scores,step=0.05,initK=1,ui2)
VectorOfSignificantSubsets=P.values<=1-pnorm(ui2)
Filter2=ConstructVectorFilter(VectorOfSignificantSubsets, SubregionsIndices)
print("The number of significant results with the RMNC")
relaxed.p.values=((p.values/relaxation2)*Filter2+(1-Filter2))
print(sum(p.adjust(relaxed.p.values,procedure)<=alpha2))
if (sum(p.adjust(relaxed.p.values,procedure)<=alpha2)>0){
print("The significant locations are")
print(c(1:M)[p.adjust(relaxed.p.values,procedure)<=alpha2])
}
