SWA=function(path, data, SubregionsIndices, WieghtsMatrix=1, option="one region to one region", alpha=0.05, MCPprocedure="bonferroni",testType = "parametric", permutations = 10000, paired=FALSE, alternative="two.sided",regressors=NULL, plotResults=FALSE,summaryFunctionName="mean"){
summaryFunction=get(summaryFunctionName) #mean
source(paste(connectomeAnalyzerPath,"reduceData.r", sep=""))
s=length(unique(SubregionsIndices[,1]))     
library(igraph)

reducedGroup1=reduceData(data$dataGroup1, summaryFunction=summaryFunction, SubregionsIndices,option=option)$reducedData      
reducedGroup2=reduceData(data$dataGroup2, summaryFunction=summaryFunction, SubregionsIndices,option=option)$reducedData
source(paste(connectomeAnalyzerPath,"computeMatrixPvalues.r", sep=""))

matrixOfPval=computeMatrixPvalues(reducedGroup1,reducedGroup2,option=option,connectomeAnalyzerPath=connectomeAnalyzerPath,testType = testType, permutations = permutations, paired=paired, alternative=alternative,regressors=regressors)
#print(min(matrixOfPval$MatrixOfPvalues))

source(paste(connectomeAnalyzerPath,"getThreshold.r", sep=""))

out=getThreshold(MatrixOfPvalues=matrixOfPval, alpha=alpha,WieghtsMatrix=WieghtsMatrix, MCPprocedure=MCPprocedure,option=option)
BlockPvalues=matrixOfPval$MatrixOfPvalues
ResultsMatrix=matrixOfPval$MatrixOfPvalues<=out$threshold
print ("The number of rejections is")
R=(sum(ResultsMatrix)/2+sum(diag(ResultsMatrix))/2)
print(R)
if (R>0){
#print(ResultsMatrix)
if(length(path) > 1){
	res_folder = '/Multivariate_results/'}
else{
	res_folder = '/Results/'}
if (file.exists(paste(path[1],res_folder,sep=""))==FALSE){
dir.create(paste(path[1],res_folder,sep=""))
}

write.table(ResultsMatrix, paste(path[1], res_folder,summaryFunctionName,"_", MCPprocedure,"_",alternative,"_alpha-",alpha,"_",testType,"_SWA.csv", sep=""))    
if (plotResults==TRUE){ 
g=graph.adjacency(matrix(as.numeric(ResultsMatrix), ncol=dim(ResultsMatrix)[1]))        
g=graph.adjacency(matrix(as.numeric(ResultsMatrix), ncol=dim(ResultsMatrix)[1]))
V(g)$label=as.character(1:s)
V(g)$color="red"
V(g)$size=6
V(g)$frame.color="red"
E(g)$color="grey70"
E(g)$weight=5
png(paste(path[1], res_folder,summaryFunctionName,"_", MCPprocedure,"_",alternative,"_","SWA.png", sep=""),width = 960, height = 960,
    units = "px", pointsize = 12, bg = "white", res = NA)
plot(g,layout=layout.circle)
dev.off()
}
}
SWAresults=NULL
SWAresults$BlockPvalues=BlockPvalues
SWAresults$BlocResultsMatrix=ResultsMatrix
SWAresults$R=R
return(SWAresults)
}


