loadRegressors=function(regressors_file,regress_separ,data_names)
{
	file_ext = strsplit(regressors_file,"\\.")[[1]][2]
	if(file_ext == 'mat'){
		stop('\n\nError: Matlab files not handled for regression files. Please specify a csv format.')
	}
	temp=read.table(regressors_file, sep=regress_separ)
	if(dim(temp)[2] < 2){
		stop('\n\nThe regression file appears to have only one column:\n\t - Make sure you have included subjects filenames and a least one regressor as the columns of the regression file.\n\t - If you are using the GUI, make sure that you selected the appropriate separator for the regression file')
	}
	Info = temp[,2:ncol(temp)]
	for(n in 1:length(data_names)){
		n_matches = sum(temp[,1] == data_names[n])
		if( n_matches > 1){
			stop(paste('\n\nError: filename "',data_names[n], '" was found ',n_matches,' times in the regression file. Unique filenames should be used to identify subject regressors.',sep=""))
		}
		if( n_matches == 0){
			stop(paste('\n\nError: filename "',data_names[n],'" was not found in the first column of the regression file. Make sure that:\n\t - you have included all the subjects of Group1 and Group2 in your regression file\n\t - you selected the appropriate separator in the GUI',sep=""))
		}
		Info[n,] = temp[match(data_names[n],temp[,1]),2:ncol(temp)]
	}
	regressors= data.frame(Info)
	return(regressors)
}
