reduceData3=function(data, summaryFunction, SubregionsIndices, option="one region to one region", matrixOfOmmitions, weighted){
# n is the number of subjects
n=dim(data)[3]
# n_variates is the number of variates
n_variates=dim(data)[4]
# s is the number of subsets
sm=length(unique(SubregionsIndices[,1]))

if (option=="one region to one region"){
	reducedData=array(0, dim=c(sm,sm,n,n_variates))
	#CorrelationsMatrix=matrix(NA, dim(data)[2],dim(data)[2])
	#SigmaMatrix=matrix(NA, sm, sm)
	for (n_var in 1:n_variates){
		for (ir in 1:(sm-1)){    # ir is the row index of the brain subregion i,
			rowIndex=as.vector(SubregionsIndices[,2][SubregionsIndices[,1]==ir])
			for(ic in (ir+1):sm){    # ic is the col index of the brain subregion i,
				colIndex=as.vector(SubregionsIndices[,2][SubregionsIndices[,1]==ic])
				for(k in 1:n){
					temp=matrix(0, length(c(rowIndex,colIndex)),length(c(rowIndex,colIndex)))
					temp[1:length(rowIndex),1:length(rowIndex)]=data[rowIndex,rowIndex,k,n_var]
					temp[1:length(rowIndex),(length(rowIndex)+1):length(c(rowIndex,colIndex))]=data[rowIndex,colIndex,k,n_var]

					temp[(length(rowIndex)+1):length(c(rowIndex,colIndex)),1:length(rowIndex)]=data[colIndex,rowIndex,k,n_var]
					temp[(length(rowIndex)+1):length(c(rowIndex,colIndex)),(length(rowIndex)+1):length(c(rowIndex,colIndex))]=data[colIndex,colIndex,k,n_var]
					reducedData[ir,ic,k,n_var]=summaryFunction(temp,weighted)
				}

				#SigmaMatrix[ir,ic]=var(as.vector(reducedData[ir,ic,]))
				#for (lr in 1: length(rowIndex)){
				#for (lc in 1: length(colIndex)){
				#CorrelationsMatrix[rowIndex[lr],colIndex[lc]]=cor(as.vector(data[rowIndex[lr],colIndex[lc],]),as.vector(reducedData[ir,ic,]))
				#}
				#}
			}
		}
		for(k in 1:n){
			reducedData[,,k,n_var]=reducedData[,,k,n_var]+t(reducedData[,,k,n_var])
		}
	}
}
if (option=="one region to all regions"){
	reducedData=array(0, dim=c(sm,1,n,n_variates))
	for(n_var in 1:n_variates){
		for (il in 1:sm){
			iindex=as.vector(SubregionsIndices[,2][SubregionsIndices[,1]==il])
			jindex=as.vector(SubregionsIndices[,2][SubregionsIndices[,1]!=il])
			for(k in 1:n){
				reducedData[il,1,k,n_var]=summaryFunction((data[iindex,jindex,k,n_var]),weighted)
			}
		}
	}
}
reduceData=NULL
reduceData$reducedData=reducedData
#reduceData$CorrelationsMatrix=CorrelationsMatrix
#reduceData$SigmaMatrix=SigmaMatrix
return(reduceData)
}
